<?php

/**
 * Klasse Sec (Security)
 * Gibt dem Benutzer die möglichkeit das Kennwort und den Benutzernamen zu ändern
 */


class Security {

	private $_bc;
	private $_ba;

	function __construct () {
		$this->_bc = new beroConf('root');
		$this->_ba = new beroAri();
	}

	private function _set_ssh_login ($enabled) {
		$this->_bc->set('root', 'ssh_admin_enable', (($enabled == '1') ? '1' : '0'));
		$passwd = '/usr/bin/passwd -' . (($enabled == 1) ? 'u' : 'l') . ' admin';
		exec('/bin/mount -oremount,rw /; ' . $passwd . '; /bin/mount -oremount,ro /');
	}

	private function _set_api_password ($user, $pass) {
		require_once('/usr/local/php/include/apiusers.Class.php');
		$apiusers=new apiusers($pass);
		$apiusers->createFile();
	}

	private function _set_ssh_password ($user, $pass) {
		exec('/usr/local/sbin/pwchange.sh admin ' . $pass);
	}

	private function _set_gui_password ($user, $pass) {
		$pass_enc = tep_encrypt_password($pass);
		$this->_ba->update('UPDATE users SET password = \'' . $pass_enc . '\' WHERE user = \'' . $user . '\'');
	}

	private function _set_passwords ($user, $pw_old, $pw_new, $pw_con) {

		# we do not like empty passwords
		if ((strlen($pw_new) == 0) || (strlen($pw_old) == 0) || (strlen($pw_con) == 0)) {
			return(1);
		}

		# old password should be correct
		$query = $this->_ba->select('SELECT password FROM users WHERE user = \'' . $user . '\'');
		$pw_chk = $this->_ba->fetch_array($query);
		if (tep_validate_password($pw_old, $pw_chk['password']) == false) {
			return(2);
		}
		unset($query);
		unset($pw_chk);

		# new password should be the same as confirmation
		if (strcmp($pw_new, $pw_con) != 0) {
			return(3);
		}

		switch ($user) {
		case 'admin':
			$this->_set_api_password($user, $pw_new);
			$this->_set_ssh_password($user, $pw_new);
		case 'beroAdmin':
			$this->_set_gui_password($user, $pw_new);
			break;
		}

		return(0);
	}

	private function _apply_changes ($session, $args) {
		if ($args['submit'] == 'Restore admin password and username') {
			$this->_set_api_password('admin', 'admin');
			$this->_set_ssh_password('admin', 'admin');
			$this->_set_gui_password('admin', 'admin');
		} else if ($args['a'] == 'save') {

			// only try to update password if some of the password-fields are set
			if ((strlen($args['pass_old']) != 0) || (strlen($args['pass_new']) != 0) || (strlen($args['pass_con']) != 0)) {
				$res = $this->_set_passwords($session['beroari_username'], $args['pass_old'], $args['pass_new'], $args['pass_con']);
				switch ($res) {
				case 1:
					$ret .= '<script>alert(\'' . SECURITY_EMP_PASS_ERROR_DIS . '\');</script>' . "\n";
					break;
				case 2:
					$ret .= '<script>alert(\'' . SECURITY_OLD_PASS_ERROR_DIS . '\');</script>' . "\n";
					break;
				case 3:
					$ret .= '<script>alert(\'' . SECURITY_CONFIRM_ERROR_DIS . '\');</script>' . "\n";
					break;
				default:
					$ret .= '<script>alert(\'' . SECURITY_SUCCES_MESSAGE_DIS . '\');</script>' . "\n";
					$ret.= '<script>$("#security_mess").hide();</script>';

				}
			}

			$this->_bc->set('root', 'api_disable', (($args['api_disable'] == '1') ? '1' : '0'));
			$this->_ba->set('dismiss_security_message', (($args['dismiss_security_message'] == '1') ? '1' : '0'));
			if ($args['dismiss_security_message'] == '1') $ret.= '<script>$("#security_mess").hide();</script>';
			
			$this->_set_ssh_login($args['ssh_admin_enable']);
			$this->_ba->update('UPDATE set_app SET show_app=\'' . (($args['show_app'] == '1') ? '1' : '0') . '\'');

			$level = 1;
			if ((($this->_bc->get('root', 'safeguard') == '1') ? '1' : '0') != (($args['safeguard'] == '1') ? '1' : '0')) {
				$this->_bc->set('root', 'safeguard', (($args['safeguard'] == '1') ? '1' : '0'));
				$level = 2;
			}
			
			$ret .= Helper::activate($level, true, $_GET['m'], ACTIVATE);
		}

		return($ret);
	}

	function display() {
                $name="SECURITY_TITLE_DIS";
		include('./includes/header.php');

		$alert = $this->_apply_changes($_SESSION, $_POST);
		if($this->_ba->get('gui_mode')=='simple') $simple_class='simple';

		$ret .=	'<br />' . "\n" .
			$this->_show_table($_GET['m'],$simple_class) .
			'<br />' . "\n" .
			$alert;

		return($ret);
	}

	private function _show_api_session () {
		$query = $this->_ba->select('SELECT show_app FROM set_app');
		while ($entry = $this->_ba->fetch_array($query)) {
		    return('<input type="checkbox" name="show_app" value="1"' . (($entry['show_app'] == '1') ? ' checked' : '') .
			    ' onmouseover="Tip(\'' . SECURITY_DISABLE_SESSION . '\')" onmouseout="UnTip()" />' . "\n");
		}
	}

	private function _show_ssh_enable () {

		$ret =	'<input type="checkbox" name="ssh_admin_enable" value="1" ' . (($this->_bc->get('root', 'ssh_admin_enable') == 1) ? 'checked="checked" ' : '') .
			' onmouseover="Tip(\'' . SECURITY_SSH_ADMIN_ENABLE . '\')" onmouseout="UnTip()" />';

		return($ret);
	}

	private function _show_dismiss_message () {

		$ret =	'<input type="checkbox" name="dismiss_security_message" value="1" ' . (($this->_ba->get('dismiss_security_message') == '1') ? 'checked="checked" ' : '') .'/>';

		return($ret);
	}
	private function _show_api_disable () {

		$ret =	'<input type="checkbox" name="api_disable" value="1" ' . (($this->_bc->get('root', 'api_disable') == '1') ? 'checked="checked" ' : '') .
			' onmouseover="Tip(\'' . SECURITY_API_DISABLE . '\')" onmouseout="UnTip()" />';

		return($ret);
	}

	private function _show_safeguard () {

		$ret =	'<input type="checkbox" name="safeguard" value="1" ' . (($this->_bc->get('root', 'safeguard') == 1) ? 'checked="checked" ' : '') .
			' onmouseover="Tip(\'' . SECURITY_SAFE_GUARD . '\')" onmouseout="UnTip()" />';

		return($ret);
	}

	private function _show_table ($module, $simple_class=null) {
		include '/usr/fallback/beroConf.php';
		require_once('./includes/lang.php');

		$ret .=	'<form name="security" id="security" method="POST" autocomplete="off">' ."\n" .
			'<input name="fixChrome" type="password" style="display:none">' . "\n" .
			'<input type="hidden" name="m" value="' . $module . '" />' . "\n" .
			'<input type="hidden" name="f" value="action" />' . "\n" .
			'<input type="hidden" name="a" value="save" />' . "\n" .
			'<table class="table table-striped table-bordered" style="max-width:500px; margin:auto;">' . "\n" .
			'<tr><th colspan="2" class="text-center">' . SECURITY_TABLE_HEADER_DIS . '</th></tr>' . "\n" .
			'<tr>' .
			'<td><b>' . SECURITY_OLD_PASS_DIS . ':</b></td>' .
			'<td><input type="password" name="pass_old" class="form-control" autocomplete="off" onmouseover="Tip(\'' . CHANGE_PWD_OLD_PASS . '\')" onmouseout="UnTip()" /></td>' .
			'</tr>' . "\n" .
			'<tr>' .
			'<td><b>' . SECURITY_NEW_PASS_DIS . ':</b></td>' .
			'<td><input type="password" name="pass_new" class="form-control" autocomplete="off" onmouseover="Tip(\'' . CHANGE_PWD_NEW_PASS . '\')" onmouseout="UnTip()" /></td>' .
			'</tr>' . "\n" .
			'<tr>' .
			'<td nowrap><b>' . SECURITY_CONFIRM_PASS_DIS . ':</b></td>' .
			'<td><input type="password" class="form-control" name="pass_con" autocomplete="off" onmouseover="Tip(\'' . CHANGE_PWD_CONFIRM_NEW_PASS . '\')" onmouseout="UnTip()" /></td>' .
			'</tr>' . "\n" .
			'<tr>' .
			'<td><b>' . SECURITY_DISMISS_SECURITY_MESSAGE_DIS . ':</b></td>' .
			'<td>' . $this->_show_dismiss_message() . '</td>' .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' .
			'<td><b>' . SECURITY_DISABLE_API_DIS . ':</b></td>' .
			'<td>' . $this->_show_api_disable() . '</td>' .
			'</tr>' . "\n" .
			'<tr>' .
			'<td><b>' . SECURITY_DISABLE_SESSIONS_DIS . ':</b></td>' .
			'<td>' . $this->_show_api_session() . '</td>' .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' .
			'<td><b>' . SECURITY_ENABLE_SSH_ADMIN_DIS . ':</b></td>' .
			'<td>' . $this->_show_ssh_enable() . '</td>' .
			'</tr>' . "\n" .
			'<tr class="'.$simple_class.'">' .
			'<td><b>' . SECURITY_SAFE_GUARD_DIS . ':</b></td>' .
			'<td>' . $this->_show_safeguard() . '</td>' .
			'</tr>' . "\n" .
			'<tr>' .
			'<td colspan="2" class="text-center">' .
			'<input name="submit" type="submit" class="btn btn-default" value="' . BUTTON_SAVE . '" onmouseover="Tip(\'' . CHANGE_PWD_SAVE . '\')" onmouseout="UnTip()" />' .
			'</td>' .
			'</tr>' . "\n" .
			'</table>' . "\n" .
			'</form>' . "\n";

		return($ret);
	}
}

?>
